<?php if (!defined('PmWiki')) exit();
/*
+----------------------------------------------------------------------+
| Copyright 2007 Hans Bracker
| This program is free software; you can redistribute it and/or modify
| it under the terms of the GNU General Public License, Version 2, as
| published by the Free Software Foundation.
| http://www.gnu.org/copyleft/gpl.html
| This program is distributed in the hope that it will be useful,
| but WITHOUT ANY WARRANTY; without even the implied warranty of
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
| GNU General Public License for more details.
+----------------------------------------------------------------------+
| foxforum.php for PmWiki and Fox (add-on to fox.php).
| Filter functions used by Fox for FoxForum and ForumX.
| Instructions on how to use it see Cookbook/FoxForum on pmwiki.org
+----------------------------------------------------------------------+
*/
$RecipeInfo['FoxForum']['Version'] = '2015-01-11';

//check for minimum PmWiki version required
if( $VersionNum<2001950 ) echo "<h3>You are running PmWiki version {$Version}. FoxForum needs a newer version of PmWiki. Please update to the latest 2.2.0 beta version</h3>"; 

// foxtemplates.php should be included in config.php
// to declares the fox/templates.d page store accessible from all pages and searches.

// add Fox in case it was not added  
if (!function_exists(FoxMarkup))
	include_once("fox.php");

// add delete links
if (!function_exists(FoxHandleDelete))
	include_once("foxdelete.php");

// add edit links
if (!function_exists(FoxHandleEdit))
	include_once("foxedit.php");

// add GUIButtons for forms in case it was not installed
if(IsEnabled($EnableGuiButtons, 1) && !function_exists(guibuttonsmarkup))
   include_once("guibuttons.php");

$group = PageVar($pagename, '$Group');

SDV($FoxForumConfig, "$group.ForumConfig");
SDV($PostsPerPage, 20);
SDV($FoxDisplayTopicTemplate, 'FoxTemplates.DisplayTemplates#default');
SDV($FoxDisplayCommentTemplate, 'FoxTemplates.DisplayTemplates#default');

// set display templates either via Profiles/Author or ForumConfig or directly
$topictpl = NULL;
$commenttpl = NULL;
if(PageExists($FoxForumConfig)) {
	$topictpl = PageTextVar($FoxForumConfig,'DisplayTopicTemplate');
	$commenttpl = PageTextVar($FoxForumConfig,'DisplayCommentTemplate');
}

// add conditional markup: (:if author AUTHORNAME:)
$Conditions['author'] = "\$GLOBALS['Author']==\$condparm";

// enable author tracking and check for preferences on Profiles page
if (IsEnabled($EnableAuthorTracking, 1)) {
	include_once("$FarmD/scripts/author.php");
	SDV($AuthorGroup,"Profiles");
	$authorpg = "$AuthorGroup/$Author";
	if(PageExists($authorpg)) {
		$dt = PageTextVar($authorpg,'DisplayTopicTemplate');
		if(!$dt=="") $topictpl = $dt;
		$ct = PageTextVar($authorpg,'DisplayCommentTemplate');
		if(!$ct=="") $commenttpl = $ct;
	}
}

if(!$topictpl) $topictpl = $FoxDisplayTopicTemplate;
if(!$commenttpl) $commenttpl = $FoxDisplayCommentTemplate;

# assign page variables for use in forum posts
$FmtPV['$DisplayTopicTemplate'] = "'$topictpl'";
$FmtPV['$DisplayCommentTemplate'] = "'$commenttpl'";
# assign page var for the name string only
$toptnm = substr(strstr($topictpl,"#"),1);
$comtnm = substr(strstr($commenttpl,"#"),1);

$FmtPV['$DisplayTopicTmplName'] = "'$toptnm'";
$FmtPV['$DisplayCommentTmplName'] = "'$comtnm'";

# add {$AuthorGroup} page variable
$FmtPV['$AuthorGroup'] = "'$AuthorGroup'";

# for transforming author names into valid wiki words, with no spaces etc.;
# used in the DisplayTemplates. (Copyright D. Faure: Cookbook.MarkupExprPlus)
$MarkupExpr['wikiword'] =
'preg_replace(array_keys($GLOBALS["MakePageNamePatterns"]),'
           . 'array_values($GLOBALS["MakePageNamePatterns"]),'
           . 'preg_replace($rpat, $rrep, $params))';


# setting pagename for topic
$FoxFilterFunctions['FoxTopicName'] = 'FoxTopicNameFilter';
function FoxTopicNameFilter($pagename, $fields) {
   //DEBUG//echo "TOPICNAME>";
   if(isset($fields['topic']) && isset($fields['foxgroup'])) {
      $tpage = FoxGroupName($pagename, $fields, $fields['topic']);
      $fields['topicpage'] = PageVar($tpage, '$Name');
   }
   return $fields;
} //}}}

# CommentForm takes PTV FoxCount from topic page for field FoxCount.
# FoxCountFilter adds 1 and puts it into field FoxCount
# This number is used for the new comment pagename suffix number
# through field value substitution.
# FoxReplacePTV is looking for PTV FoxCount on topic page
# and replaces its value with the new incremented value.

// FoxCount filter 
$FoxFilterFunctions['FoxCount'] = 'FoxCountFilter';
# increase FoxCount field by 1
function FoxCountFilter($pagename, $fx) {
		$fc = PageTextVar( $pagename, 'FoxCount');
     	$fx['FoxCount'] = sprintf("%03d",$fc+1);
   return $fx;
} //}}}

# set urlfmt to go to last page when posting
$FoxFilterFunctions['FoxBreakPageUrl'] = 'FoxBreakPageUrl';
function FoxBreakPageUrl($pagename, $fields) {
   global $PostsPerPage, $ScriptUrl, $EnablePathInfo;
   $group = PageVar($pagename, '$Group');
   $name = PageVar($pagename, '$Name');
   $fc = PageTextVar($pagename, 'FoxCount');
   $r = fmod($fc-1,$PostsPerPage);
   $p = ceil(intval($fc)/$PostsPerPage);
 	$PageUrl = ($EnablePathInfo) ? "$ScriptUrl/$group/$name" : "$ScriptUrl?n=$pagename";   
   $fields['urlfmt'] = "$PageUrl?p=$p";      
   return $fields;   
} //}}}

if ($FoxForum['type'] = 'standard') {
		# foxbreakpage for one page per topic forums

		# display page in break chunks, display page links
		function FoxBreakPage($pagename, $text) {
			global $FoxForumConfig, $PostsPerPage;
			$grp = PageVar($pagename, '$Group');
			$ppp = PageTextVar( $FoxForumConfig, 'PostsPerPage');
			if(!$ppp) $ppp = $PostsPerPage; if($ppp==0) $ppp=1; //prevent div by zero error
			$text = str_replace('(:foxbreakpage:)','', $text);
			$p = explode('#foxbegin', $text);
			foreach($p as $k => $post) {
				$p[$k] = "#foxbegin".$post;
			}
			$p[0] = str_replace('#foxbegin', '', $p[0]);
			$new = array_splice($p, 0, 1);
			while(count($p)>0) {
				$sp = array_splice($p, 0, $ppp);
				$new[] = implode('', $sp);
			}
			$n = @$_REQUEST['p'];
			$nc = count($new)-1;
			if ($n<1) $n=1;  
			if ($n>$nc) $n=$nc;   
			$out = "<div class='breaklist lfloat'>".XL('Page');
			for($i=1; $i<=$nc; $i++) {
				if ($i==$n) $out .= " $n";
				else 
					$out .= FmtPageName(" <a href='\$PageUrl?p=$i'>$i</a>",$pagename);
			}
			$out .= '</div>';
			//if($n==1) return $new[0].$new[1];
			//else 
			return $new[0].Keep($out).$new[$n].Keep($out);
		} //}}}  
		# markup (:foxbreakpage:) breakpage nav links
		if ($action=='browse')
			Markup_e('foxbreakpage','<foxentry','/^.*\\(:foxbreakpage:\\).*$/s',
				 "FoxBreakPage(\$pagename,\$m[0])");
		else Markup('foxbreakpage','directives','/\\(:foxbreakpage:\\)/',
				 "");
} //end standard forum type 


if($FoxForum['type'] == 'extended') {
		# breakpagelist for one post per page forums

		# {$FoxListStart} and {$FoxListEnd} for pagelist
		$FmtPV['$FoxBreakFirst'] = 'FoxBreakPageList($pagename, "first")';
		$FmtPV['$FoxBreakLast'] = 'FoxBreakPageList($pagename, "last")';
		$FmtPV['$FoxBreakMax'] = 'FoxBreakPageList($pagename, "max")';
		#$FoxBreakMaxUrl = "{={$FoxBreakMax}";
		#echo $FoxBreakMaxUrl;
		$FmtPV['$FoxBreakMaxUrl'] = '$GLOBALS["$FoxBreakMaxUrl"]';
		# count post pages
		$page = PageVar($pagename, '$FullName');

		$FoxPageCount = count(ListPages("/^$page-\\d*$/")); 

		$FmtPV['$FoxPageCount'] = '$GLOBALS["FoxPageCount"]';
		$FmtPV['$FoxPageCountDec'] = '$GLOBALS["FoxPageCount"]-1';
		$FmtPV['$FoxPageCountInc'] = '$GLOBALS["FoxPageCount"]+1';


		# calculate first and last # for breakpage list, generate links
		function FoxBreakPageList($pagename, $opt) {
			global $FoxForumConfig, $PostsPerPage, $FoxPageCount, $FoxLastPage, $FoxBreakMax;
			$ppp = PageTextVar( $FoxForumConfig, 'PostsPerPage');
			if(!$ppp) $ppp = $PostsPerPage; if($ppp==0) $ppp=1; //prevent div by zero error
			$fc = $FoxPageCount;
			$r = fmod($fc-1,$ppp);
			$p = ceil(intval($fc)/$ppp);
			$max = $p;
			if ($p<=0) $p=1;
			$n = @$_REQUEST['p'];
			if ($n<1) $n=1;  
			if ($n>$p) $n=$p;
			$last = $n*$ppp;
			if($last >= $fc) $FoxLastPage = 1; 
			switch($opt) {
			case 'first':
				return ($n-1)*$ppp+1;
			case 'last':
				return $last;
			case 'max': 
				return $max;
			case 'links':
				if ($p==1) return "&nbsp;";
				$out = "<div class='breaklist'>".XL('Page');
				for($i=1; $i<=$p; $i++) {
					if ($i==$n) $out .= " $n";
					else 
						$out .= FmtPageName(" <a href='\$PageUrl?p=$i'>$i</a>",$pagename);
				}
				$out .= '</div>';
				return Keep($out);
			}
		} //}}}  

		# markup (:foxbreakpage:) breakpage nav links
		if ($action=='browse')
			Markup('breakpagelist','<directives','/\\(:foxbreakpagelist:\\)/se',
				"FoxBreakPageList(\$pagename,'links')");
		else Markup('foxbreakpagelist','directives','/\\(:foxbreakpagelist:\\)/',
				 "");
} //end extended forum type

# fmt=count for pagelist, included here for conveniance (original in fplcount.php) 
SDVA($FPLFormatOpt['count'], array('fn' => 'FPLCount2'));
function FPLCount2($pagename, &$matches, $opt) {
  $matches = array_values(MakePageList($pagename, $opt, 0));
  return count($matches);
} //}}}

# invisible (::textvar:...::) markup
Markup('textvar::', '<split',
  '/\\(::\\w[-\\w]*:(?!\\)).*?::\\)/s', '');

# add new PTV pattern for text PTV (::var:...::)
$PageTextVarPatterns['(::var:...::)'] = '/(\\(:: *(\\w[-\\w]*) *:(?!\\))\\s?)(.*?)(::\\))/s';

