#! /usr/bin/env python
#{{{ File header information
#	vim:ff=unix ts=4 ss=4
#	\file		clean-RecentChanges.py
#	\date		Thu, 12 Apr 2007 15:31 PDT
#
#	\brief		Special case little python to trim a few entries from the
#				RecentChanges pages for PmWiki
#
#	\author		Kimberly Kelly <sreny@srenyqernzf.pbz> (Rot13ed)
#	\note		Public Domain, enjoy!
#	Version:	0.1
#	USAGE:		Place this in your wiki root or wherever you desire and adjust
#				g_source_path accordingly.
#}}}

#Folder to cleanse...
g_source_path = "./"

###################################################
# No //need// to worry about what is below
###################################################

import os
import sys
import fnmatch
import string
import time

def processfile(p_file, p_path): # {{{
#	print "PROCESSING:", p_file, p_path
	file_name = os.path.join(p_path, p_file)
	print "PROCESSING:", file_name

	out_lines=[]
	f = open(file_name,'r')
	for line in f:
		work = line.strip()

		if work.startswith('diff:'):
			pass
		elif work.startswith('author:'):
			pass
		elif work.startswith('host:'):
			pass
		elif work.startswith('rev'):
			out_lines.append('rev=0')
		else:
			out_lines.append(work)
	f.close()


#	for line in out_lines:
#		print line

	f = open(file_name,'w')
	for line in out_lines:
		f.write(line)
		f.write('\n')
	f.close()

# }}}

def main(): # {{{
	"Entry point into this script."

	base_path = os.path.dirname(sys.argv[0])
	input_path = os.path.normpath(os.path.join(base_path,g_source_path) )

	for root, dirs, files in os.walk(input_path):
#		files = fnmatch.filter(files, "*RecentChanges") # remove any entries which do not match our mask
		files = fnmatch.filter(files, "*.[!p][!y]*") # remove any entries which do not match our mask
		for file in files:
			processfile(file, root)
# }}}


if __name__ == '__main__':
	"Entry point when ran just by itself."
	main()

#
# EOF

